<template>
  <v-window v-model="position" show-arrows show-arrows-on-hover continuous dark>
    <v-window-item v-for="(group, idx) in groups" :key="idx">
      <v-row dense>
        <v-col v-for="(column, idp) in group" :key="idp" :cols="idx ? 4 : 12 - (4 * (idp + 1))">
          <v-row dense>
            <v-col v-for="photo in column" :key="photo.src" cols="12">
              <v-img :src="photo.src" aspect-ratio="1.724" @click="$emit('selected', getIndex(photo.src))">
                <template v-slot:placeholder>
                  <v-skeleton-loader type="image" height="100%" light />
                </template>
              </v-img>
            </v-col>
          </v-row>
        </v-col>
      </v-row>
    </v-window-item>
  </v-window>
</template>

<script lang="ts">
import { IPhoto } from 'apartments-shared'
import { defineComponent, ref } from '@vue/composition-api'
import chunk from 'lodash.chunk'

export default defineComponent({
  props: {
    photos: {
      type: Array as () => IPhoto[],
      required: true
    }
  },
  setup ({ photos }) {
    const colums: Array<IPhoto[]> = [[photos[0]], ...chunk(photos.slice(1), 2)]
    const groups: Array<Array<IPhoto[]>> = [colums.slice(0, 2), ...chunk(colums.slice(2), 3)]
    const position = ref(0)
    const getIndex = (src: string) => photos.findIndex(p => p.src === src)
    return { groups, position, getIndex }
  }
})
</script>
